#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    spvUnsafeArray<float4, 3> u_DirLightsColor;
    spvUnsafeArray<float, 3> u_DirLightsIntensity;
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    spvUnsafeArray<float4, 2> u_PointLightsPosition;
    spvUnsafeArray<float4, 2> u_PointLightsColor;
    spvUnsafeArray<float, 2> u_PointLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_PointLightsEnabled;
    spvUnsafeArray<float4, 2> u_SpotLightsDirection;
    spvUnsafeArray<float4, 2> u_SpotLightsPosition;
    spvUnsafeArray<float4, 2> u_SpotLightsColor;
    spvUnsafeArray<float, 2> u_SpotLightsIntensity;
    spvUnsafeArray<float, 2> u_SpotLightsInnerAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsOuterAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_SpotLightsEnabled;
    float4 u_WorldSpaceCameraPos;
    float4 u_AlbedoColor;
    float4 u_SpecularColor;
    float u_SpecularIntensity;
    float u_SpecularPower;
};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float3 g_vary_WorldPosition [[user(locn1)]];
    float3 g_vary_WorldNormal [[user(locn2)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    float3 _717 = fast::normalize(in.g_vary_WorldNormal);
    float3 _734 = fast::normalize(buffer.u_WorldSpaceCameraPos.xyz - in.g_vary_WorldPosition);
    float4 _2705 = float4(buffer.u_SpecularColor.xyz * buffer.u_SpecularIntensity, buffer.u_SpecularPower);
    float3 _859 = fast::normalize(-buffer.u_DirLightsDirection[0].xyz);
    bool _1022 = buffer.u_DirLightsEnabled[0] > 0.5;
    float3 _2685;
    if (_1022)
    {
        _2685 = ((((buffer.u_AlbedoColor.xyz * fma(dot(_717, _859), 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _859)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_DirLightsIntensity[0]) * buffer.u_DirLightsColor[0].xyz) * buffer.u_DirLightsEnabled[0];
    }
    else
    {
        _2685 = float3(0.0);
    }
    bool _1043 = buffer.u_DirLightsEnabled[1] > 0.5;
    float3 _2686;
    if (_1043)
    {
        float3 _1048 = fast::max(fast::normalize(-buffer.u_DirLightsDirection[1].xyz), float3(0.001000000047497451305389404296875));
        _2686 = _2685 + (((((buffer.u_AlbedoColor.xyz * fma(dot(_717, _1048), 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _1048)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_DirLightsIntensity[1]) * buffer.u_DirLightsColor[1].xyz) * buffer.u_DirLightsEnabled[1]);
    }
    else
    {
        _2686 = _2685;
    }
    float3 _2689;
    if (_1022)
    {
        float3 _1187 = (buffer.u_PointLightsPosition[0].xyz - in.g_vary_WorldPosition) * buffer.u_PointLightsAttenRangeInv[0];
        float _1189 = length(_1187);
        float3 _1194 = _1187 / float3(fast::max(_1189, 0.001000000047497451305389404296875));
        float _1200 = dot(_717, _1194);
        _2689 = (((((buffer.u_AlbedoColor.xyz * fma(_1200, 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _1194)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_PointLightsIntensity[0]) * buffer.u_PointLightsColor[0].xyz) * (((pow(fast::clamp(1.0 - pow(_1189, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1189, 2.0) + 1.0)) * fast::max(0.0, _1200))) * buffer.u_PointLightsEnabled[0];
    }
    else
    {
        _2689 = float3(0.0);
    }
    float3 _2690;
    if (_1043)
    {
        float3 _1243 = (buffer.u_PointLightsPosition[1].xyz - in.g_vary_WorldPosition) * buffer.u_PointLightsAttenRangeInv[1];
        float _1245 = length(_1243);
        float3 _1250 = _1243 / float3(fast::max(_1245, 0.001000000047497451305389404296875));
        float _1256 = dot(_717, _1250);
        _2690 = _2689 + ((((((buffer.u_AlbedoColor.xyz * fma(_1256, 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _1250)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_PointLightsIntensity[1]) * buffer.u_PointLightsColor[1].xyz) * (((pow(fast::clamp(1.0 - pow(_1245, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1245, 2.0) + 1.0)) * fast::max(0.0, _1256))) * buffer.u_PointLightsEnabled[1]);
    }
    else
    {
        _2690 = _2689;
    }
    float3 _2693;
    if (_1022)
    {
        float3 _1413 = (buffer.u_SpotLightsPosition[0].xyz - in.g_vary_WorldPosition) * buffer.u_SpotLightsAttenRangeInv[0];
        float _1415 = length(_1413);
        float3 _1420 = _1413 / float3(fast::max(_1415, 0.00999999977648258209228515625));
        float _1426 = dot(_717, _1420);
        _2693 = (((((buffer.u_AlbedoColor.xyz * fma(_1426, 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _1420)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_SpotLightsIntensity[0]) * buffer.u_SpotLightsColor[0].xyz) * ((((pow(fast::clamp(1.0 - pow(_1415, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1415, 2.0) + 1.0)) * fast::max(0.0, _1426)) * smoothstep(buffer.u_SpotLightsOuterAngleCos[0], buffer.u_SpotLightsInnerAngleCos[0], fast::max(0.0, dot(_1420, fast::normalize(-buffer.u_SpotLightsDirection[0].xyz)))))) * buffer.u_SpotLightsEnabled[0];
    }
    else
    {
        _2693 = float3(0.0);
    }
    float3 _2694;
    if (_1043)
    {
        float3 _1483 = (buffer.u_SpotLightsPosition[1].xyz - in.g_vary_WorldPosition) * buffer.u_SpotLightsAttenRangeInv[1];
        float _1485 = length(_1483);
        float3 _1490 = _1483 / float3(fast::max(_1485, 0.00999999977648258209228515625));
        float _1496 = dot(_717, _1490);
        _2694 = _2693 + ((((((buffer.u_AlbedoColor.xyz * fma(_1496, 0.5, 0.5)) + (_2705.xyz * pow(fast::clamp(dot(_717, fast::normalize(_734 + _1490)), 0.0, 1.0), buffer.u_SpecularPower))) * buffer.u_SpotLightsIntensity[1]) * buffer.u_SpotLightsColor[1].xyz) * ((((pow(fast::clamp(1.0 - pow(_1485, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1485, 2.0) + 1.0)) * fast::max(0.0, _1496)) * smoothstep(buffer.u_SpotLightsOuterAngleCos[1], buffer.u_SpotLightsInnerAngleCos[1], fast::max(0.0, dot(_1490, fast::normalize(-buffer.u_SpotLightsDirection[1].xyz)))))) * buffer.u_SpotLightsEnabled[1]);
    }
    else
    {
        _2694 = _2693;
    }
    out.o_fragColor = float4(pow((_2686 + _2690) + _2694, float3(0.454545438289642333984375)), buffer.u_AlbedoColor.w);
    return out;
}

